#pragma once
#include <sys/time.h>

struct packet
{
	struct timeval timestamp;
	unsigned int channel;
	unsigned int rate;
	int signal;
	unsigned int noise;
	char source[18];
	int cell_x;
	int cell_y;
	//char destination[18];
	//unsigned int mgmt;
	//unsigned int ctrl;
	//unsigned int data;
};

#ifdef __cplusplus
extern "C"
#endif
void call_signalmap_set( struct packet* pkg );

#ifdef __cplusplus
extern "C"
#endif
void call_signalmap_dump();

#ifdef __cplusplus
extern "C"
#endif
void call_signalmap_writeToFile(char* fileName);

