#include "signalmap.h"
#include "math.h"
#include <time.h>
#include <stdlib.h>

SignalMap* SignalMap::pinstance = NULL;

SignalMap* SignalMap::Instance () 
{
	if(pinstance==NULL)
	{	
		pinstance = new SignalMap();
		pinstance->current_x=-10; //init
		pinstance->current_y=-10;	//init
		
	}
	
	return pinstance;
		
}

void StringToLower(char* strToConvert)
{
	unsigned int i=0;
	for(i=0;strToConvert[i] != '\0';i++)
		strToConvert[i] = tolower(strToConvert[i]);
}	


void SignalMap::set( packet* pkg )
{

	runtimeCell* curCell;
	//cout
	if( (pkg->cell_x!=current_x || pkg->cell_y!=current_y) && current_x!=-10 && current_y!=-10){  //1h fora pou divazoume times apo neo runtime cell(ejairesh to 1o sto 1o read),eisagoume tis times pou mazepsame apo to prohgoiumeno runtime cell stis domes
		//cout<<"Enter"<<endl;
		curCell=new pair<Point*, Snapshot>;
		//cout<<"(x,y) Inside signalMap:"<<pkg->cell_x<<","<<pkg->cell_y<<endl;
		curCell->first=new Point(current_x,current_y);
		//curCell->second=new Snapshot();
		curCell->second=(*_map);
		runtimeCells.push_back(curCell);	
		_map->clear();
		//cout<<"map size:"<<_map->size()<<endl;
		}
		current_x=pkg->cell_x;
		current_y=pkg->cell_y;

     if(current_x!=-100 && current_y!=-100){ //last "dummy" packet,used to insert collected,we don't want to collect any more vals

	StringToLower(pkg->source);
	gettimeofday(&pkg->timestamp,NULL);
	if ( pkg->source != NULL && strlen(pkg->source) == 17 )
	{
		//cout << "set source: " << pkg->source << endl;
		vector<signalStamp*>* current_vector = _map->operator[](pkg->source);
		if ( current_vector == NULL ){
			current_vector = new vector<signalStamp*>();
			//cout<<"NULL OLE"<<endl;
		}
		signalStamp* stamp = new signalStamp();
		stamp->timestamp = pkg->timestamp;
		//cout << pkg->signal;
		//getchar();
		stamp->noise=pkg->noise;
		stamp->signal = pkg->signal;
		current_vector->push_back( stamp );
		_map->operator[](pkg->source) = current_vector;
	   }
	}
	Snapshot::iterator iterMap;//=_map->find(pkg->source);
	//cout<<"Map size:"<<_map->size()<<"-mac:"<<pkg->source<<endl;
	/*if(iterMap==_map->end())  //Den vrethike ara einai neo ap

	{
		cout<<"Neo ap"<<endl;
		//vector<signalStamp*>* current_vector=new vector<signalStamp*>();
		
		//current_vector->clear();
		//signalStamp* stamp = new signalStamp();
		//stamp->timestamp = pkg->timestamp;
		//stamp->signal = pkg->signal;
		//current_vector->push_back( stamp);
		//bool inserted=false;;
		//_map->insert((make_pair(pkg->source,current_vector)));
		//if(p.second==false)
		//	cout<<"Apotyxia eisagwghs.."<<endl;

	}

	else if(iterMap!=_map->end())

	{	cout<<"Current ap"<<endl;
		//signalStamp* stamp = new signalStamp();
		//stamp->timestamp = pkg->timestamp;
		//stamp->signal = pkg->signal;
		//((*_map)[pkg->source])->push_back( stamp);

		
	}
	else{
	cout<<"Paparia mentoles"<<endl;	cout<<"args:"<<argc<<endl;		}*/
	
	/*for(iterMap=_map->begin(); iterMap!=_map->end(); iterMap++){
		cout << "Key: '" << iterMap->first << endl;//"', size: " << iterMap->second->size() << endl;
	}
	iterMap=_map->find(pkg->source);
	if(iterMap==_map->end())  //Den vrethike ara einai neo ap
		cout<<"new ap"<<endl;
	else if(iterMap!=_map->end()){
		cout<<"APO SIGNALMAP:::pkg_source: "<<pkg->source<<",siz	cout<<"args:"<<argc<<endl;	e :"<<((*_map)[pkg->source])->size()<<", Vals: ";	
		
		for( vector<signalStamp*>::iterator it =((*_map)[pkg->source])->begin(); it != 	((*_map)[pkg->source])->end(); it++ )
				cout<<(*it)->signal<<"--";
			cout<<endl;

	}
	else{
		cout<<"Paparia mentoles"<<endl;
	}*/
	

	


 
		//cout<<"what 4"<<endl;
		//cout << "set source: " << pkg->source << endl;
		//vector<signalStamp*>* current_vector = _map->operator[](pkg->source);	cout<<"args:"<<argc<<endl;	
		//cout<<"what 5"<<endl;
		//if ( current_vector == NULL ){
		//	current_vector = new vector<signalStamp*>();
		//	cout <<"Neos vector gia "<< pkg->source<<".size: "<<current_vector->size()<<endl;
		//}//
		//cout<<"what 6"<<endl;
		//signalStamp* stamp = new signalStamp();
		//cout<<"what 7"<<endl;	
		//stamp->timestamp = pkg->timestamp;
		//cout<<"what 8"<<endl;
		//cout << pkg->signal;
		//getchar();
		//stamp->signal = pkg->signal;
		//cout<<"what 9"<<endl;
		//current_vector->push_back( stamp );
	//	cout<<"APO SIGNALMAP:::pkg_source: "<<pkg->source<<",size :"<<current_vector->size()<<", Vals: ";	
				
	//		for( vector<signalStamp*>::iterator it = current_vector->begin(); it != current_vector->end(); it++ )
	//			cout<<(*it)->signal<<"--";
	//		cout<<endl;
	//	
	//	_map->operator[](pkg->source) = current_vector;
	
}

SignalMap::SignalMap():
_map( new Snapshot() )
{
}

void SignalMap::dump()
{
	printf("\033[%d;%dH",0, 0);
	for( Snapshot::iterator it = _map->begin(); it != _map->end(); it++ )
	{
		vector<signalStamp*>* vec = it->second;
		cout << it->first << " \t--\t " << vec->size();
		for ( vector<signalStamp*>::iterator it2 = vec->begin(); it2 != vec->end(); it2++ )
			cout << " " << (*it2)->signal;
		float mean = Math::getMean( vec );
		float interval = Math::getInterval( vec, mean ); 
		cout << endl;
		cout << "(" << mean-interval << ", " << interval +mean << ")" << endl; 
	}
}

void SignalMap::writeToFile( char* fileName )
{
	FILE* fp = fopen(fileName,"w+");
	printf("Opening file: %s\n", fileName );	
	for( Snapshot::iterator it = _map->begin(); it != _map->end(); it++ )
	{
		vector<signalStamp*>* vec = it->second;
		fprintf(fp, "%s ", it->first );
		for ( vector<signalStamp*>::iterator it2 = vec->begin(); it2 != vec->end(); it2++ )
			fprintf(fp, " %d ", (*it2)->signal);
		fprintf(fp, "\n");
	}
	printf("Closing file\n" );
	fclose(fp);         
}

void SignalMap::writeToFileWithTimestamps( char* fileName )
{
	FILE* fp = fopen(fileName,"a");
	printf("Opening file: %s\n", fileName );	
	for( Snapshot::iterator it = _map->begin(); it != _map->end(); it++ )
	{
		vector<signalStamp*>* vec = it->second;
		for ( vector<signalStamp*>::iterator it2 = vec->begin(); it2 != vec->end(); it2++ )
			fprintf(fp, "%u.%06u \t %s\t %d\n", (unsigned)(*it2)->timestamp.tv_sec, (unsigned)(*it2)->timestamp.tv_usec, it->first, (*it2)->signal);
	}
	printf("Closing file\n" );
	fclose(fp);         
}

void SignalMap::clear()
{
	_map->clear();
	runtimeCells.clear();
}

Snapshot* SignalMap::getSnapshot()
{
	Snapshot* result = new Snapshot();
	for ( Snapshot::iterator it = _map->begin(); it != _map->end(); it++ )
	{
		vector<signalStamp*>* output_vector = new vector<signalStamp*>();
        	for ( vector<signalStamp*>::iterator it2 = it->second->begin(); it2 != it->second->end(); it2++ )
		{
			struct timeval current_time;
	                gettimeofday(&current_time, NULL);
			signalStamp* stamp = (signalStamp*)*it2;
			output_vector->push_back( stamp );
			result->operator[](it->first) = output_vector;
		}
	}
	return result;
}
vector<runtimeCell*> SignalMap::getRunCells(){
	return SignalMap::Instance()->runtimeCells;
}

extern "C" void call_signalmap_set( struct packet* pkg )
{
	SignalMap::Instance()->set(pkg);
}

extern "C" void call_signalmap_dump()
{
	SignalMap::Instance()->dump();
}

extern "C" void call_signalmap_writeToFile( char* fileName )
{
	SignalMap::Instance()->writeToFile(fileName);
}

extern "C" void call_signalmap_writeToFileWithTimestamps( char* fileName )
{
	SignalMap::Instance()->writeToFileWithTimestamps(fileName);
}

